/******************************************************
EEE410 PROJECT 2012.11.5
"DIGITAL VOLTMETER"
SUPERVISOR: RAUF MRZABABAYEV
STUDENTS: EMRE ZKORKMAZ, MESUT TRK, MER METE ATALAY
*******************************************************/
#include <16f877.h>    

#device ADC=10  // 10 bitlik ADC 

// Denetleyici konfigrasyon ayarlar
#fuses XT,NOWDT,NOPROTECT,NOBROWNOUT,NOLVP,NOPUT,NOWRT,NODEBUG,NOCPD

#use delay (clock=4000000) // Gecikme fonksiyonu iin kullanlacak osilatr frekans belirtiliyor.
#use rs232 (baud=2400, xmit=pin_C6, rcv=pin_C7,enable=pin_c0,bits=9, parity=N,stop=1)
#use fast_io(c) //Port ynlendirme komutlar C portu iin geerli
#use fast_io(e) //Port ynlendirme komutlar E portu iin geerli
#use fast_io(d)
#define use_portb_lcd TRUE   // LCD B portuna bal

#include <lcd.c>   // lcd.c dosyas tantlyor
#INT_AD               // ADC evrimi bitti kesmesi
void ADC_Kesmesi ( )
{
   output_high(pin_c0);  // RC5 k 1
   delay_ms(100);
   output_low(pin_c0);   // RC5 k 0
}
unsigned long int bilgi; // aretsiz 16 bitlik tam say tipinde deiken tanmlanyor
float voltaj;            // ondalkl tipte voltaj isminde deiken tantlyor
float list[20]={0};  // deerlerin kaydedilecei dizi
int tab=0; // menden klp klmayacan belirlemek iin
int sendcont=0; // gnderme ilemini kontrol etmek iin
int sample=5; // alnmas istenen rnek says
int16 time=50; // ka ms arayla lm yaplacak
int i=0;// dizinin indexi
int k=0; // lm test indexi
void show()
{
printf(lcd_putc,"\f%i.=%f",i,list[i]);
}
void sendcomputer() //grderme fonksiyonu
 {
 for(i=0;i<sample;i++)
 {
  putc(list[i]);
 }
 printf(lcd_putc,"\f Data is sent");  
  delay_ms(1000);  
 }

//********** ANA PROGRAM FONKSYONU*******

void main ( )
{
   setup_psp(PSP_DISABLED);        // PSP birimi devre d
   setup_timer_1(T1_DISABLED);     // T1 zamanlaycs devre d
   setup_timer_2(T2_DISABLED,0,1); // T2 zamanlaycs devre d
   setup_CCP1(CCP_OFF);            // CCP1 birimi devre d
   setup_CCP2(CCP_OFF);            // CCP2 birimi devre d
   set_tris_a(0xff);
   set_tris_c(0x00);  // C portu komple k
   set_tris_d(0xff);
    output_c(0x00);    // C portu kn sfrla
    output_d(0xff);
    output_high(pin_c0); output_low(pin_c0);delay_ms(150);
    output_high(pin_c0); output_low(pin_c0);delay_ms(150);
   
   setup_adc(adc_clock_div_32);   // ADC clock frekans fosc/32
   setup_adc_ports(an0);   // pin_a0 analog ayarlanyor
   enable_interrupts(INT_AD);     // AD evrimi bitti kesmesi tantlyor
   enable_interrupts(GLOBAL);     // Tm kesmeler aktif

   lcd_init();                            // LCD hazr hale getiriliyor

   printf(lcd_putc,"\f EEE410 PROJECT"); // LCD'ye yaz yazdrlyor
   delay_ms(1000);
   printf(lcd_putc,"\fDIGITAL "); // LCD'ye yaz yazdrlyor
   lcd_gotoxy(1,2);
   printf(lcd_putc,"VOLTMETER");
   delay_ms(1200);
   printf(lcd_putc,"\fSUPERVISOR:"); // LCD'ye yaz yazdrlyor
   delay_ms(500);
   printf(lcd_putc,"\fPROF.DR. RAUF");
   lcd_gotoxy(1,2);
   printf(lcd_putc,"MIRZABABAYEV");
   delay_ms(2000);
    printf(lcd_putc,"\fSTUDENTS :"); // LCD'ye yaz yazdrlyor
   delay_ms(500);
     printf(lcd_putc,"\fEMRE OZKORKMAZ"); // LCD'ye yaz yazdrlyor
   delay_ms(1000);
    printf(lcd_putc,"\fMESUT TURK"); // LCD'ye yaz yazdrlyor
   delay_ms(1000);
    printf(lcd_putc,"\fOMER METE ATALAY"); // LCD'ye yaz yazdrlyor
   delay_ms(1000);
   tab=0;
   while(true)   // sonsuz dng
   {
   if(!input(pin_d7)) // show 
   {
   while(!input(pin_d7));
 {  i=0;
   show();
  if(tab==0)
  tab=1;
  else
  tab=0;
  }
   } 
   
  if(!input(pin_d6)) // gster butonu baslms iken ekranda sonraki deeri gstermeye yarar
  {
  while(!input(pin_d6));
  {
  if(i<20)
  i++;
  else i=20;
  }
  show();
  } // pin-d6
  
  if(!input(pin_d4)) // gster butonu baslm iken ekranda nceki deeri gstermeye yarar.
  {
  while(!input(pin_d4));
 { 
  if(i>0)
  i--;
  else i=0;
  show();
  }
  }// pin_d4
  
  if(!input(pin_d5)) // lmler aras sreyi arttr
  {
  while(!input(pin_d5));
  {
  if(time<20000) // max 20sn atadk
  time=time+25; // art oran 25 msn
  else 
  time=20000;
  }
  printf(lcd_putc,"\fTstep=%lu ms",time);
  }// pin d5
  
  if(!input(pin_d1)) // lmler aras sreyi azalt
  {
  while(!input(pin_d1));
  {
  if(time>25) // minimum deer olarak 25 atand
  time-=25;
  else
  time=25;
  }
  printf(lcd_putc,"\fTstep=%lu ms",time);
  }//pin_d1
  
  if(!input(pin_d0))// alnacak sample saysn arttrr
  {
  while(!input(pin_d0)); 
  {
  if(sample<20)
  sample++;
  else
  sample=20;
  }
  printf(lcd_putc,"\fNsample=%i",sample);
  }// pin_d0
    
   if(!input(pin_d3))// alnacak sample saysn azalt
  {
  while(!input(pin_d3)); 
  {
  if(sample>0)
  sample--;
  else
  sample=0;
  }
  printf(lcd_putc,"\fNsample=%i",sample);
  }// pin_d3
  
 if(!input(pin_d2))// alnan rnekleri gnder veya bala
  {
  while(!input(pin_d2)); 
  {
  if(sendcont==0)
  {
  printf(lcd_putc,"\fTo send wait the");
  printf(lcd_putc,"\nmeasurements");
  delay_ms(1000);
  for(k=0;k<sample;k++)
  {
  set_adc_channel(0);
  delay_us(20);
  bilgi=read_adc();
  voltaj=0.0048828125*bilgi*43;
  list[k]=voltaj;
  printf(lcd_putc,"\f Measuring...");
  printf(lcd_putc,"\n%i. sample=%.3f",k,list[k]);
  delay_ms(time);
  }
  if(k==sample)
 {
  printf(lcd_putc,"\fMeasuring is");
  printf(lcd_putc,"\n completed");
  delay_ms(1000);
  }
  printf(lcd_putc,"\fPress Send to");
  printf(lcd_putc,"\nsend to computer");
  delay_ms(1200);
  sendcont=1; // kontrol deikeni deitriliyor
  }
  else
  {
  printf(lcd_putc,"\f sending.");
  delay_ms(600);
   printf(lcd_putc,"\f sending..");
  delay_ms(600);
   printf(lcd_putc,"\f sending...");
  delay_ms(600);
   printf(lcd_putc,"\f sending.");
  delay_ms(600);
   printf(lcd_putc,"\f sending..");
  delay_ms(600);
   printf(lcd_putc,"\f sending...");
  delay_ms(600);
   delay_ms(600);
   printf(lcd_putc,"\f sending.");
  delay_ms(600);
   printf(lcd_putc,"\f sending..");
  delay_ms(600);
   printf(lcd_putc,"\f sending...");
  delay_ms(600);
 sendcomputer();
  sendcont=0; // kontrol deikeni tekrar sfrlanyor
  }
  
  }
  
  }// pin_d2

   if(tab==0)
   {
     
      set_adc_channel(0);   // RE0/AN5 ucundaki sinyal A/D ilemine tabi tutulacak
      delay_us(20);         // Kanal seiminde sonra bu bekleme sresi verilmelidir
      bilgi=read_adc();     // ADC sonucu okunuyor ve bilgi deikenine aktarlyor
      voltaj=0.0048828125*bilgi*43;   // Dijitale evirme ilemine urayan sinyalin gerilimi hesaplanyor
      printf(lcd_putc,"\fDijital=%lu",bilgi); // analog bacaa gelen sinyalin digital deeri
      printf(lcd_putc,"\nVoltaj=%.3fV",voltaj); // gerek voltaj deeri yazdrlyor
      delay_ms(30) ;
   }
   }
}
